=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2007-01-02 00:55:28 +0000
+++ loggerhead/changecache.py	2007-01-02 04:34:09 +0000
@@ -145,6 +145,7 @@
             # must call into history so we grab the branch lock (otherwise, lock inversion)
             self.history.get_changes(r)
             if self.closed():
+                self.flush()
                 return
             count += jump
             now = time.time()
@@ -156,6 +157,8 @@
                 self.log.info('Revision cache rebuilding continues: %d/%d' % (min(count, len(work)), len(work)))
                 last_update = time.time()
                 self.flush()
+            # give someone else a chance at the lock
+            time.sleep(1)
         self.log.info('Revision cache rebuild completed.')
         self.flush()
 

=== modified file 'loggerhead/lockfile.py'
--- loggerhead/lockfile.py	2007-01-02 00:55:28 +0000
+++ loggerhead/lockfile.py	2007-01-02 04:34:09 +0000
@@ -61,7 +61,8 @@
     def acquire(self):
         # try over and over, sleeping on exponential backoff with an upper limit of about 5 seconds
         pause = 0.1
-        max_pause = 5.0
+        #max_pause = 5.0
+        max_pause = 0.1
         while True:
             if self._try_acquire():
                 return

=== modified file 'loggerhead/textindex.py'
--- loggerhead/textindex.py	2007-01-02 00:55:28 +0000
+++ loggerhead/textindex.py	2007-01-02 04:34:09 +0000
@@ -189,6 +189,7 @@
             if not self.is_indexed(revid):
                 self.index_change(self.history.get_changes([ revid ])[0])
             if self.closed():
+                self.flush()
                 return
 
             count += 1
@@ -203,6 +204,8 @@
                 self.log.info('Search indexing continues: %d/%d' % (min(count, len(work)), len(work)))
                 last_update = time.time()
                 self.flush()
+            # give someone else a chance at the lock
+            time.sleep(1)
         self.log.info('Search index completed.')
         self.flush()
 

